<?php

/*
 * Helper class for Gavick TabArts module
*
* Gavick TabMods
* @package Joomla!
* @Copyright (C) 2008 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @ version $Revision: 1.0 $
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class TabArtsHelper{
	
	var $moduleWidth, $moduleHeight, $tabsGroupID, $tabsScroll, $activator, $animation, $animationType, $animationSpeed, $buttons, $styleCSS, $styleFile, $useMoo, $useScript, $tabsTitles, $tabsArts, $style, $styleCSSfile, $modGetter, $animationFun, $module_id, $animationInterval, $showTitle, $textLimit, $textLimitValue, $styleType, $hstyle, $news_readmore_text, $news_header_link, $news_image_link, $news_text_link, $news_limit_type, $news_limit, $clean_xhtml, $img_height, $img_width;
	
	function init(&$params){
		$this->moduleWidth = $params->get('moduleWidth', 0);
		$this->moduleHeight = $params->get('moduleHeight', 0);
		$this->tabsGroupID = $params->get('tabsGroupID', 0);
		$this->styleCSS =  $params->get('styleCSS', 'style1');
		$this->styleFile = $params->get('styleFile', '');
		
		$this->tabsTitles = array();
		$this->tabsArts = array();

		$db	=& JFactory::getDBO();
		// przygotowanie zapytania MySQL
		$query = 'SELECT * FROM #__gk_tabsman_tabs WHERE group_id = '.$this->tabsGroupID.' ORDER BY `order` ASC;';
		// wykonanie zapytania MySQL
		$db->setQuery($query);
		// przetworzenie wynikw zapytania
		$rows = $db->loadObjectList();
		
		foreach($rows as $row){
			$this->tabsTitles[] = $row->name;
			$this->tabsArts[] = $row->content;
		}
		
		if(strpos($this->moduleHeight,'px') === false) $this->moduleHeight = 0;
		if(strpos($this->moduleWidth,'px') === false && strpos($this->moduleWidth,'%') === false ) $this->moduleWidth = 0;

		if($this->moduleHeight == 0){
			$this->style = ($this->moduleWidth == 0) ? '' : 'width: '.$this->moduleWidth.';';
			$this->hstyle = ($this->moduleWidth == 0) ? '' : 'width: '.$this->moduleWidth.';';
		}
		else{
			$this->style = ($this->moduleWidth == 0) ? 'height: '.$this->moduleHeight.';' : 'height: '.$this->moduleHeight.';width: '.$this->moduleWidth.';';
			$this->hstyle = ($this->moduleWidth == 0) ? '' : 'width: '.$this->moduleWidth.';';
		}
		
		$this->styleCSSfile = ($this->styleCSS == "own") ? $this->styleFile : $this->styleCSS;
	}
	
	function render(&$params){
		$this->activator = $params->get('activator','click');
		$this->animation = $params->get('animation',0);
		$this->animationSpeed = $params->get('animationSpeed', 1000);
		$this->animationInterval = $params->get('animationInterval', 5000);
		$this->useMoo = $params->get('useMoo',1);
		$this->useScript = $params->get('useScript',1);
		$this->animationType = $params->get('animationType', 1);
		$this->buttons = $params->get('buttons', 1);
		$this->styleCSS = $params->get('styleCSS', 'style');
		$this->animationFun = $params->get('animationFun', 33);
		$this->module_id = $params->get('module_id', '-mod');
		$this->styleType = $params->get('styleType', 0);
		
		$this->news_readmore_text = $params->get('news_readmore_text', 'Readmore'); // text for news readmore button
		$this->news_header_link = $params->get('news_header_link', 1); // add link to header ? (boolean)
		$this->news_image_link = $params->get('news_image_link', 1); // add link to image ? (boolean)
		$this->news_text_link = $params->get('news_text_link', 0); // add link to text ? (boolean)
		$this->news_limit_type = $params->get('news_limit_type', 0); // type of limit fo news text
		$this->news_limit = $params->get('news_limit', 30); // amout of limit "units"
		$this->clean_xhtml = $params->get('clean_xhtml', 1); // cleaning XHTML in news
		$this->img_height = $params->get('img_height', 0); // image height
		$this->img_width = $params->get('img_width', 0); // image width
		
		if(strpos($this->img_height,'px') === false && strpos($this->img_height,'%') === false) $this->img_height = 0;# Height image
		if(strpos($this->img_width,'px') === false && strpos($this->img_width,'%') === false) $this->img_width = 0;# Width image
		
		require(JModuleHelper::getLayoutPath('mod_tabarts','default'));
	}
	
	function articleRender(){
		global $mainframe;
	
		$db	=& JFactory::getDBO();
		$user =& JFactory::getUser();
		$aid = $user->get('aid', 0);
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$noauth	= !$contentConfig->get('shownoauth');
		$now = date('Y-m-d H:i:s', time() + $mainframe->getCfg('offset') * 60 * 60);
		$nullDate = $db->getNullDate();
		// przygotowanie zapytania MySQL
		$where = '';
		for($i = 1; $i < count($this->tabsArts); $i++) $where .= ' OR (content.id = '.$this->tabsArts[$i].')';
		
		$query = '
			SELECT
				cats.section AS SID, 
				content.title AS title, 
				content.introtext AS text, 
				content.images AS images, 
				content.id AS id,
				
				CASE WHEN CHAR_LENGTH(content.alias) 
					THEN CONCAT_WS(":", content.id, content.alias) 
						ELSE content.id END as ID, 
				CASE WHEN CHAR_LENGTH(cats.alias) 
					THEN CONCAT_WS(":", cats.id, cats.alias) 
						ELSE cats.id END as CID 
						
			FROM 
				#__content AS content 
				LEFT JOIN 
					#__categories AS categories 
					ON categories.id = content.catid 
				LEFT JOIN 
					#__sections AS sections 
					ON sections.id = content.sectionid 
				LEFT JOIN 
					#__categories AS cats 
					ON content.catid = cats.id 
			WHERE 
			 ( (content.id = '.$this->tabsArts[0].') '.$where.' );';
		
		// wykonanie zapytania MySQL
		$db->setQuery($query);
		// przetworzenie wynikw zapytania
		$artsTitles = array();
		$artsContent = array();
		$artSIDs = array();
		$artIDs = array();
		$artCIDs = array();
		$artImages = array();

		foreach($db->loadObjectList() as $row){
			$artTitles[$row->id] = $row->title;
			$artContent[$row->id] = $row->text;
			$artSIDs[$row->id] = $row->SID;
			$artIDs[$row->id] = $row->ID;
			$artCIDs[$row->id] = $row->CID;
			$artImages[$row->id] = $row->images;
		}
		
		for($abc = 0;$abc < count($this->tabsArts);$abc++){
			$title = ($this->news_header_link == 1) ? '<h4><a href="'.JRoute::_(ContentHelperRoute::getArticleRoute($artIDs[$this->tabsArts[$abc]], $artCIDs[$this->tabsArts[$abc]], $artSIDs[$this->tabsArts[$abc]])).'">'.$artTitles[$this->tabsArts[$abc]].'</a></h4>' : '<h4>'.$artTitles[$this->tabsArts[$abc]].'</h4>';
			
			// GENERATING IMAGE
			$news_image = '';
			$IMG_SOURCE = '';
			$IMG_LINK = JRoute::_(ContentHelperRoute::getArticleRoute($artIDs[$this->tabsArts[$abc]], $artCIDs[$this->tabsArts[$abc]], $artSIDs[$this->tabsArts[$abc]]));
				
			$imgSPos = strpos($artContent[$this->tabsArts[$abc]],'src="');
			$imgEPos = strpos($artContent[$this->tabsArts[$abc]],'"',$imgSPos+5);
				
			if($imgSPos > 0) $IMG_SOURCE = substr($artContent[$this->tabsArts[$abc]], ($imgSPos+5), ($imgEPos-($imgSPos+5)));
			if($IMG_SOURCE != ''){
				$news_image_style = '';
			
				if($this->img_height != 0) $news_image_style .= 'height: '.$this->img_height.';';
				if($this->img_width != 0) $news_image_style .= 'width: '.$this->img_width.';';
			
				if($this->news_image_link == 1){
					$news_image = ($this->news_content_image_pos == 3) ? '<div><a href="'.$IMG_LINK.'"><img src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" /></a></div>' : '<a href="'.$IMG_LINK.'"><img src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" /></a>';
				}
				else{
					$news_image = ($this->news_content_image_pos == 3) ? '<div><img src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" /></div>' : $news_image = '<img src="'.$IMG_SOURCE.'" style="'.$news_image_style.'" alt="News image" />';
				}
			}
			
			($this->textLimit == 0) ? $content = $artContent[$this->tabsArts[$abc]] : $content = (substr(strip_tags($artContent[$this->tabsArts[$abc]]), 0, $this->textLimitValue)).'...';
			
			$content = '';
			$content = str_replace('{mosimage}', '', $artContent[$this->tabsArts[$abc]]);
			
			if($this->clean_xhtml == 1) $content = strip_tags($content);
			
			if($this->news_limit_type == 0){
				$str = $content;
				
				if(strlen($str)>$this->news_limit){
					$words=explode(' ',preg_replace("/\s+/",' ',preg_replace("/(\r\n|\r|\n)/"," ",$str)));
				
					if(count($words)>=$this->news_limit){
						$str = '';
						for ($i=0;$i<$this->news_limit;$i++){$str.=$words[$i].' ';}
						$content = trim($str);
						$content .= "...";
					}
				}
			}
			else{
				$str = $content;
				
				if(strlen($str)>$this->news_limit){
					$str = preg_replace("/\s+/", ' ', preg_replace("/(\r\n|\r|\n)/", " ", $str));
				
					if(strlen($str) >= $this->news_limit){						
						$content = substr($str,0,$this->news_limit);
						$content .= "...";
					}
				}
			}
					
			$news_readmore = '<a class="readon" href="'.JRoute::_(ContentHelperRoute::getArticleRoute($artIDs[$this->tabsArts[$abc]], $artCIDs[$this->tabsArts[$abc]], $artSIDs[$this->tabsArts[$abc]])).'">'.$this->news_readmore_text.'</a>';
					
			$content = ($this->news_text_link == 1) ? '<a href="'.JRoute::_(ContentHelperRoute::getArticleRoute($artIDs[$this->tabsArts[$abc]], $artCIDs[$this->tabsArts[$abc]], $artSIDs[$this->tabsArts[$abc]])).'">'.$content.'</a>' : $content; 
			$content = '<p class="gk_news_show_news_text">'.$content.' '.$news_readmore.'</p>';
			
			include(JModuleHelper::getLayoutPath('mod_tabarts','module'));
		}
	}
}

?>